/*
	Author: 				Hamza
	Description: 			O(N^2logN) solution where for each query maintain the 
							segments online through using a multiset.
*/
#include <algorithm>
#include <iostream>
#include <cassert>
#include <climits>
#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <numeric>
#include <random>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <ctime>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <bitset>
#include <unordered_map>
#define ll long long
#define ii pair<int, int>
#define sz(x) x.size()
#define st first
#define nd second
#define N 1000005
using namespace std;

int n, m;
vector<vector<int>> a;
int bad_rows, bad_cols, bad_segments;
int cnt_r[N], cnt_c[N], mx_r[N], mn_r[N], mx_c[N], mn_c[N];
ii q[N];
multiset<ii> segments;

void update_bad_cols(int col, int mult) {

	if(mx_c[col] < mn_c[col])
		return ;
	if(cnt_c[col] != mx_c[col] - mn_c[col] + 1)
		bad_cols += mult;

}

void update_bad_rows(int row, int mult) {

	if(mx_r[row] < mn_r[row])
		return ;
	if(cnt_r[row] != mx_r[row] - mn_r[row] + 1)
		bad_rows += mult;

}

void update_bad_segments(ii l, ii r, int mult) {

	if(-l.nd < -r.nd)
		bad_segments += mult;

}

void add_segment(int l, int r) {

	auto pos = segments.insert({l, -r});
	bool L = false, R = false;
	if(pos != segments.begin()) {
		L = true;
		update_bad_segments(*prev(pos), *pos, 1);
	}
	if(next(pos) != segments.end()) {
		R = true;
		update_bad_segments(*pos, *next(pos), 1);
	}
	if(L && R) {
		update_bad_segments(*prev(pos), *next(pos), -1);
	}

}

void del_segment(int l, int r) {

	auto pos = segments.find({l, -r});
	if(pos == segments.end())
		return ;
	bool L = false, R = false;
	if(pos != segments.begin()) {
		L = true;
		update_bad_segments(*prev(pos), *pos, -1);
	}
	if(next(pos) != segments.end()) {
		R = true;
		update_bad_segments(*pos, *next(pos), -1);
	}
	if(L && R) {
		update_bad_segments(*prev(pos), *next(pos), 1);
	}
	segments.erase(pos);

}

bool check() {

	if(bad_rows or bad_cols or bad_segments) {
		return false;
	}
	return true;

}

int main() {

	ios_base :: sync_with_stdio(0);
	cin.tie(0);cout.tie(0);

	cin >> n >> m;

	assert(n*m <= 175000);
	a = vector<vector<int>>(n + 1, vector<int>(m + 1, 0));
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			int x;
			cin >> x;
			q[x] = {i, j};
		}
	}
	for(int i = 0; i < n; i++) {
		mx_r[i] = -1;
		mn_r[i] = m;
	}
	for(int i = 0; i < m; i++) {
		mx_c[i] = -1;
		mn_c[i] = n;
	}
	string result;
	for(int i = 1; i <= n * m; i++) {
		a[q[i].st][q[i].nd] = 1;

		update_bad_rows(q[i].st, -1);
		update_bad_cols(q[i].nd, -1);
		del_segment(mn_r[q[i].st], mx_r[q[i].st]);
		mx_r[q[i].st] = max(mx_r[q[i].st], q[i].nd);
		mn_r[q[i].st] = min(mn_r[q[i].st], q[i].nd);
		cnt_r[q[i].st]++;

		mx_c[q[i].nd] = max(mx_c[q[i].nd], q[i].st);
		mn_c[q[i].nd] = min(mn_c[q[i].nd], q[i].st);
		cnt_c[q[i].nd]++;
		add_segment(mn_r[q[i].st], mx_r[q[i].st]);
		update_bad_cols(q[i].nd, 1);
		update_bad_rows(q[i].st, 1);

		result.push_back('0' + check());
	}
	cout << result;

}