/*
	Author: 				Hamza
	Description: 			O(N) solution
*/

#include <algorithm>
#include <iostream>
#include <cassert>
#include <climits>
#include <cstdlib>
#include <cstring>
#include <iomanip>
#include <numeric>
#include <random>
#include <cstdio>
#include <string>
#include <vector>
#include <cmath>
#include <ctime>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include<bitset>
#define ll long long
#define ii pair<int, int>
#define sz(x) x.size()
#define st first
#define nd second
#define N 300005
using namespace std;

int n, k;
int best[N][2], far_n[N], far_s[N], spe[N];
vector<int> v[N];
ll ans;
ii dn, ds;

void update_best(int node, int val) {

	best[node][1] = max(best[node][1], val);
	if(best[node][1] > best[node][0])
		swap(best[node][1], best[node][0]);

}

void dfs_up(int node, int dad, int u) {

	if(spe[node]) {
		ans = max(ans, far_n[node] + (ll) (k - 2) * far_s[node] + max(u, best[node][0]));
	}
	for(int go: v[node]) {
		if(go == dad)
			continue ;
		int u_cd = (best[node][0] == best[go][0] + 1 ? best[node][1] : best[node][0]);
		dfs_up(go, node, max(u, u_cd) + 1);
	}

}

void dfs_sub(int node, int dad) {

	for(int go: v[node]) {
		if(go == dad)
			continue ;
		dfs_sub(go, node);
		update_best(node, best[go][0] + 1);
	}
	if(spe[node]) {
		update_best(node, far_n[node]);
	}

}

void dfs_dia_s(int node, int dad, int dist) {

	if(dad == 0) 
		ds = {0, 0};
	if(spe[node]) {
		ds = max(ds, {dist, node});
		far_s[node] = max(far_s[node], dist);
	}
	for(int go: v[node]) {
		if(go == dad)
			continue ;
		dfs_dia_s(go, node, dist + 1);
	}

}

void dfs_dia_n(int node, int dad, int dist) {

	if(dad == 0)
		dn = {0, 0};
	dn = max(dn, {dist, node});
	far_n[node] = max(far_n[node], dist);
	for(int go: v[node]) {
		if(go == dad)
			continue ;
		dfs_dia_n(go, node, dist + 1);
	}

}

int main() {

	ios_base :: sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> k;
	for(int i = 2; i <= n; i++) {
		int p;
		cin >> p;
		v[p].push_back(i);
		v[i].push_back(p);
	}
	// read 1010 string
	string prop;
	cin >> prop;
	int s_node = -1;
	for(int i = 0; i < n; i++) {
		if(prop[i] - '0') {
			spe[i + 1] = 1;
			s_node = i + 1;
		}
	}
	if(s_node == -1) {
		dfs_dia_n(1, 0, 0);
		dfs_dia_n(dn.nd, 0, 0);
		cout << dn.st;
		return 0;
	}
	
	dfs_dia_n(1, 0, 0);
	dfs_dia_n(dn.nd, 0, 0);
	dfs_dia_n(dn.nd, 0, 0);

	dfs_dia_s(s_node, 0, 0);
	dfs_dia_s(ds.nd, 0, 0);
	dfs_dia_s(ds.nd, 0, 0);
	
	if(k & 1) {
		for(int i = 1; i <= n; i++) {
			if(spe[i]) {
				ans = max(ans, (ll) (k - 1) * far_s[i] + 2 * far_n[i]);
			}
		}	
	} 
	else {
		dfs_sub(1, 0);
		dfs_up(1, 0, 0);
	}
	cout << ans;

}